﻿Imports System.IO

Public Class Form1
    Private _sourceDir As String
    Private _destDir As String
    Private Sub BtnSource_Click(sender As Object, e As EventArgs) Handles btnSource.Click
        If FolderBrowserDialog1.ShowDialog(Me) = DialogResult.OK Then
            _sourceDir = FolderBrowserDialog1.SelectedPath
            VulListView(_sourceDir, lvSource)
            If lvDestination.Items.Count > 0 Then
                lvDestination.Focus()
                lvDestination_SelectedIndexChanged(lvDestination, Nothing)
            End If
            fwSource.EnableRaisingEvents = False
            fwSource.Path = _sourceDir
            fwSource.NotifyFilter = NotifyFilters.DirectoryName Or NotifyFilters.FileName
            fwSource.IncludeSubdirectories = False
            fwSource.Filter = "*"
            AddHandler fwSource.Created, AddressOf OnChanged
            AddHandler fwSource.Changed, AddressOf OnChanged
            AddHandler fwSource.Deleted, AddressOf OnChanged
            fwSource.EnableRaisingEvents = True

        End If
    End Sub
    Private Sub OnChanged(aSource As Object, e As FileSystemEventArgs)
        MessageBox.Show("Opgelet: de inhoud van de directories is gewijzigd")
    End Sub
    Private Sub btnDest_Click(sender As Object, e As EventArgs) Handles btnDest.Click
        If FolderBrowserDialog1.ShowDialog(Me) = DialogResult.OK Then
            _destDir = FolderBrowserDialog1.SelectedPath
            VulListView(_destDir, lvDestination)
            If lvSource.Items.Count > 0 Then
                lvSource.Focus()
                lvSource_SelectedIndexChanged(lvSource, Nothing)

            End If
            fwDestination.EnableRaisingEvents = False
            fwDestination.Path = _destDir
            fwDestination.NotifyFilter = NotifyFilters.DirectoryName Or NotifyFilters.FileName
            fwDestination.IncludeSubdirectories = False
            fwDestination.Filter = "*"
            AddHandler fwDestination.Created, AddressOf OnChanged
            AddHandler fwDestination.Changed, AddressOf OnChanged
            AddHandler fwDestination.Deleted, AddressOf OnChanged
            fwDestination.EnableRaisingEvents = True
        End If

    End Sub
    Private Sub VulListView(aFolder As String, aListview As ListView)
        aListview.Items.Clear()
        Dim directories() As String = Directory.GetDirectories(aFolder)
        Dim files() As String = Directory.GetFiles(aFolder)
        For Each directory As String In directories
            Dim di As DirectoryInfo = New DirectoryInfo(directory)
            Dim li As ListViewItem = New ListViewItem({di.Name, "", di.LastWriteTime.ToShortDateString}, 0)
            aListview.Items.Add(li)
        Next
        For Each file As String In files
            Dim fi As FileInfo = New FileInfo(file)
            Dim li As ListViewItem = New ListViewItem({fi.Name, fi.Length.ToString, fi.LastWriteTime.ToShortDateString}, 1)
            aListview.Items.Add(li)
        Next
    End Sub
    Private Sub KopieerBestanden(aSource As ListView, aDestination As ListView)
        For Each li As ListViewItem In aSource.SelectedItems
            Dim su As ListViewItem.ListViewSubItem = li.SubItems(0)
            Dim sourceBestand As String = _sourceDir & "\" & su.Text
            Dim destBestand As String = _destDir & "\" & su.Text
            Try
                If li.ImageIndex = 0 Then
                    KopieerDirectory(New DirectoryInfo(sourceBestand), destBestand)
                Else
                    KopieerBestand(New FileInfo(sourceBestand), destBestand)
                End If
                Dim subItemArray(li.SubItems.Count - 1) As ListViewItem.ListViewSubItem
                For i As Integer = 0 To li.SubItems.Count - 1
                    subItemArray(i) = li.SubItems(i)
                Next
                Dim liDest As ListViewItem = New ListViewItem(subItemArray, li.ImageIndex)
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
        Next
    End Sub
    Private Sub KopieerBestand(aSource As FileInfo, aDest As String)
        aSource.CopyTo(aDest, False)
    End Sub
    Private Sub KopieerDirectory(aSource As DirectoryInfo, aDest As String)
        If Directory.Exists(aDest) Then Throw New IOException("Directory bestaat al")
        Directory.CreateDirectory(aDest)
        For Each fsi As FileSystemInfo In aSource.GetFileSystemInfos
            Dim di As DirectoryInfo = TryCast(fsi, DirectoryInfo)
            If di IsNot Nothing Then
                KopieerDirectory(di, aDest & "\" & di.Name)
            Else
                KopieerBestand(DirectCast(fsi, FileInfo), aDest & "\" & fsi.Name)
            End If
        Next
    End Sub

    Private Sub lvSource_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lvSource.SelectedIndexChanged
        btnRechts.Enabled = lvSource.SelectedItems IsNot Nothing
        btnLinks.Enabled = lvDestination.SelectedItems IsNot Nothing
    End Sub

    Private Sub lvDestination_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lvDestination.SelectedIndexChanged
        btnRechts.Enabled = lvSource.SelectedItems IsNot Nothing
        btnLinks.Enabled = lvDestination.SelectedItems IsNot Nothing
    End Sub

    Private Sub btnRechts_Click(sender As Object, e As EventArgs) Handles btnRechts.Click
        KopieerBestanden(lvSource, lvDestination)
        VulListView(_destDir, lvDestination)
    End Sub

    Private Sub btnLinks_Click(sender As Object, e As EventArgs) Handles btnLinks.Click
        KopieerBestanden(lvDestination, lvSource)
        VulListView(_sourceDir, lvSource)
    End Sub
End Class
